/*     DS18B20.
*/

//--------------------------------------------------------------------------------------- 
//#pragma jis									//        
#include <xc.h>							//   
#include "ds18b20.h"						//
//--------------------------------------------------------------------------------------- 


//========================================================================================
//     DS18B20
//========================================================================================
//;Level_High:      -     DS18B20
void Level_HIGH (void)
{
	DALLAS=1;				//          
	__delay_us(6);			// 10         
	TRISDAL=1;				//     
}//--------------------------------------------------------------------------------------- 

//========================================================================================
// Level_LOW:     
void Level_LOW (void)
{
	DALLAS=0;				//    			
	TRISDAL=0;				//    
	__delay_us(1);			// 3   
}//---------------------------------------------------------------------------------------

//========================================================================================
// DLIT_WR:   
//  60 mks,    DS1820      .
void Waiting_WR (void)
{
	__delay_us(52);			//52   
}//---------------------------------------------------------------------------------------

//========================================================================================
//crc_bits:    crc8  DS18B20
char CRC_BITS (int data) 
{
  int i = (data ^ crc) & 0xff;
  crc = 0;
	  if(i & 0b00000001)crc ^= 0x5e;
	  if(i & 0b00000010)crc ^= 0xbc;
	  if(i & 0b00000100)crc ^= 0x61;
	  if(i & 0b00001000)crc ^= 0xc2;
	  if(i & 0b00010000)crc ^= 0x9d;
	  if(i & 0b00100000)crc ^= 0x23;
	  if(i & 0b01000000)crc ^= 0x46;
	  if(i & 0b10000000)crc ^= 0x8c;
  return crc;
}//---------------------------------------------------------------------------------------





//========================================================================================
//RESET_DALLAS:      
//  	0 -    
//				1 -      ()
//				2 -       ()
char Reset_Dallas (void)
{
char ERR_LINE; //     c
unsigned char a;
			Level_LOW();				//   >480 mks
			__delay_us(700);			// 700 mks

//   ,    
			ERR_LINE=0;//    -     c
			di();// 			

//tttt3:		di();					//  
//			if(GIE==1)goto tttt3;	//  

			Level_HIGH();				//  
		//	__delay_us(15);				// 15 mks
		//     
			a=0;
			while (ERR_LINE==0&&DALLAS==1)
			{
				CLRWDT(); 
				__delay_us(5);			// 5 mks
				if(++a>120)ERR_LINE=1; 	//   -   
			}	 
			ei();// 

		//    ,   	
			a=0;
			while (ERR_LINE==0&&DALLAS==0)
			{
				CLRWDT(); 
				__delay_us(5);			// 5 mks
				if(++a>120)ERR_LINE=2; 	//   -   
			}	 
			
			__delay_us(700);			//  >480 mks

		//	ERR_LINE=0;//test alarm
		return ERR_LINE;
}//---------------------------------------------------------------------------------------




//========================================================================================
// Dreceive:      DS18B20.
char Dreceive (void)
{
char COM_REG,a;	
	COM_REG=0;
	for (a=0; a<8; a++)						//     
	{										//
tttt0:	di();					//  
		if(GIE==1)goto tttt0;	//  
		Level_LOW ();						//      )
		Level_HIGH ();						//  
		COM_REG=COM_REG>>1;					//  +   7  0
		if (DALLAS==1)COM_REG |= 0b10000000;//   7  1  DALLAS==1
		ei();	//   
		Waiting_WR();						//     
	}
return COM_REG;
}//---------------------------------------------------------------------------------------

//========================================================================================
// Dsend:      DS1820.
void Dsend(char COM_REG) 
{
char a;
	for (a=0; a<8; a++)	
	{
tttt1:	di();					//  
		if(GIE==1)goto tttt1;	//  
		Level_LOW ();		
		if(COM_REG & 0b00000001) Level_HIGH ();
		COM_REG=COM_REG>>1;	
		ei();	//   
		Waiting_WR ();
	 	Level_HIGH ();
	}
}//---------------------------------------------------------------------------------------

// 
//===========================================================================
char Init_ds18b20(void)
{
        char i=0;
        temp_ds=0;
		i=Reset_Dallas();//   
		Dsend (0xCC);
		Dsend(0x4E); 			//    ds18b20
		Dsend(0x00);
		Dsend(0x00);
		Dsend(0x1F);			//   9  
		return i;
}
//========================================================================================
/*celsio:      .   
   ,  ,      EEPROM 
 .     . 
 
NACHAD -     
COLDAT -   

// 
//  0;  //     
//  1; //  
//  2; //  
//  3; //    -        
//  4; //    -    
//  5; //   
*/
char Celsio (void)
{
char a; //   

const char con_dro[] = { 0, 1, 1, 2, 3, 3, 4, 4, 5, 6, 6, 7, 8, 8, 9, 9, 00}; 
             //         00.06.13.19.25.31.38.44.50.56.63.69.75.81.88.94.100   


static bit MINUS;	

	if(CONFLAG==1)//    
	{
		if(CONV==0)	
			{CONFLAG=0;}
 		else return 2; //  
	}
	else
	{
		a=Reset_Dallas();//   
		if (a==0)
		{
			Dsend (0xCC);//    
			Dsend (0x44);//  
			CONV=1;
			CONFLAG=1;
			temp_ds=1;
		 	return 1; // 
		}
		else
		{
			if (a==1) return 3; //  - ,     )
			else return 4; //  -   ( )
		}
	}
//  
//----------------------------------------------------------------------		
//	nomdat=0;
	while (1)
	{
							

//	    crc
		Reset_Dallas();//   
		Dsend (0xCC);
		Dsend(0xBE); 			//   
		crc=0; 					//    			
		tempertura=Dreceive(); 	//   01
		CRC_BITS(tempertura);
		a=Dreceive(); 			//   02
		tempertura+=a<<8;		
		CRC_BITS(a);
		CRC_BITS(Dreceive()); 	//   03
		CRC_BITS(Dreceive()); 	//   04
		CRC_BITS(Dreceive()); 	//   05
		CRC_BITS(Dreceive()); 	//   06
		CRC_BITS(Dreceive()); 	//   07
		CRC_BITS(Dreceive()); 	//   08
		CRC_BITS(Dreceive()); 	//   09

//  ,      	
		if(crc!=0)		// 0=      <10
		{
			err_crc=1;
		}				
		else
		{
			err_crc=0;	
		}
//----------------------------------------------------------------	
//       c
		MINUS=0;
		if (tempertura & 0x8000)
		{
			tempertura=-tempertura; //  
				MINUS=1;
		}	
		a=tempertura;		//   
		a &= 0b00001111;	//   
		a=con_dro[a];		//
					
		tempertura>>=4;		//   
		tempertura=(tempertura&0x00ff); // , 22,5 
		tempertura=tempertura+a;		   // 225
		
		if (MINUS==1)
		{
			tempertura=-tempertura;
		}
    	return 0;			
	}	
	return 0;
}//---------------------------------------------------------------------------------------


