#include <xc.h>
#include "main.h"
#include "ds18b20.h"
//------------------------------------------------------------------------------
							
//  PIC12F675/PIC12F629,  -     4v.

//------------------------------------------------------------------------------
//  

#pragma config LVP = OFF
#pragma config FOSC = INTOSCCLK  // 
#pragma config WDTE = ON		// WDT enabled
#pragma config PWRTE = ON		// PWRT enabled
#pragma config MCLRE = ON		// MCLR/VPP pin function is digital input
#pragma config CP = OFF			// Program memory code protection is enabled
#pragma config CPD = OFF                 // Data memory code protection is enabled
#pragma config BOREN = ON		// Brown-out Reset enabled     

#define _XTAL_FREQ 	4000000         //        


//--------------------------------------------------------------------
// 
void interrupt my_isr(void) 	//
{
	if(TMR1IE&&TMR1IF)
	{ 
        TMR1IF=0 ; CONV=0; TMR1IE=0; 
        counter_err++;
        if(counter_err==4)
		{ counter_err=0; err_flag++; }
    }
	
}//end_interrupt----------------------------------------------------------------


int main(void)
{
	char error_ds18b20;
    char error_flag;     //  ,   
    volatile char tempp,temp1;


//==============================================================
    init(); //   
	err_ds=Init_ds18b20();  //   1  2,  
    //====================================================================
	//   
	while(1)
    {
    //--------------------------------------------------------------------
        CLRWDT(); 		//   +++++++++++++++++++++-
        
		// 
		//  0;  //     
		//  1; //  
		//  2; //  
		//  3; //    -        
		//  4; //    -    
		//  5; //   

        error_ds18b20=Celsio(); // 
        
        if(temp_ds==1) 
		{
			TMR1L=0;
			TMR1H=0;
            TMR1IE=1;
			TMR1IF=0;
			temp_ds=0;  //      ds18b20	
		}
		//=====================================================================
		if(error_ds18b20==0)
		{
			tempp=1;
            temper_ds18b20=tempertura;
            tempertura=0;
		}
		else
		{ tempp=0; }
//=======================================================================
        //      -   
        if((temper_ds18b20>=ystav)||err_crc||(error_ds18b20==3)||(error_ds18b20==4)||(error_ds18b20==5))
		{
            //error_flag=1;
			//GPIO0=0;
			RA2=0;
		}
		else
		{  RA1=1; RA2=1; error_flag=0; }
//========================================================================================
       //     , 
       if(err_crc||(error_ds18b20==3)||(error_ds18b20==4)||(error_ds18b20==5))
		{
            error_flag=1;
		}
	   else { error_flag=0; }
       if(error_flag)
	   {
           TMR1IE=1;
           temp1=err_flag&0x01;
           if(temp1)
			{ RA1=1; }
		    else { RA1=0; }
		}
       else 
      { 
			if(temper_ds18b20>=ystav) RA1=0; 
            else RA1=1; 
       }  
       
       CLRWDT();
        //GPIO0 = !GPIO0;
        //__delay_ms(500);


    }// end while

    return 0;
}

void init()
{
	PORTA=0x00;
	INTCON=0b11000000; //    
	PIR1=0x00;
	T1CON=0b00010001; //   1, 2 = 65*2=130 
	CMCON=0x07;  //    
	OPTION_REG=0x8F; //   
					 //   WDT /128
    TRISA=0x0b11111001;
	PIE1=0x00; //   
	//WPU=0x00;  //   
    CCP1CON=0x00; //  
    VRCON=0x00;   //    
}